#ifndef ICE_TIME
#define ICE_TIME

#include "../Util/StringEx.h"
#include "../Util/IOX.h"

typedef unsigned short int usi;

class Timestamp{
 public:
  Timestamp(const string& date);

  bool operator< (const Timestamp& other);
  bool operator< (const Timestamp& other) const;

  bool operator> (const Timestamp& other);
  bool operator> (const Timestamp& other) const;
  
  Timestamp operator= (const Timestamp& other);

  bool operator== (const Timestamp& other);
  bool operator== (const Timestamp& other) const;
  
  Timestamp operator+ (const Timestamp& other);

  string getstr() const {
    string res = to_str<unsigned short int>(Y);
    res += "-" + to_str<usi>(M) + "-" + to_str<usi>(D) + " " + to_str<usi>(H) + ":" + to_str<usi>(N) + ":" + to_str<usi>(S);
    return res;
  }
  
  string getSimpleStr(){
    string res = to_str<unsigned short int>(Y);
    if (M < 10)
      res += "0";
    res += to_str<usi>(M);
    if (D < 10)
      res += "0";
    res += to_str<usi>(D);
    return res;
  }

  bool isValid(){return valid;};
  void print() const{
    cerr << Y << "-" << M << "-" << D << " " << H << ":" << N << ":" << S << endl;
  }

  void print(){
    const_cast<const Timestamp*>(this)->print();
  }

 private:
  unsigned short int Y, M, D, H, N, S;
  string dateStr;
  bool valid;
  bool CheckBounds();
  
  void Reduce();
  bool Error(const string& message);
};

#endif
