#ifndef ICE_RAND
#define ICE_RAND

#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <random>

using namespace std;

class PowerLaw{
 public:
 PowerLaw(double minimum, double maximum, double exponent):min(minimum), max(maximum), exp(exponent){
    srand(time(NULL));
  }

  double sample(){
    double unif  = ((double)rand() / (double)RAND_MAX);
    while (unif == 0)
      unif = ((double)rand() / (double)RAND_MAX);

    return pow(((pow(max, exp+1) - pow(min, exp+1)) * unif) + pow(min, exp+1), 1./(exp + 1));
  }

 private:
  double min, max, exp;
};

class Exponential{
 public:
 Exponential(double exp):x(exp), m(1./exp){
    srand(time(NULL));
  }

 Exponential(double exp, double mean):x(exp), m(mean){
    srand(time(NULL));
  }

 Exponential(double exp, unsigned long int seed):x(exp), m(1./exp){
    srand(seed);
  }

 Exponential(double exp, double mean, unsigned long int seed):x(exp), m(mean){
    srand(seed);
  }

  double sample(){
    double unif = double(rand()) / double(RAND_MAX);
    while (unif == 0)
      unif = double(rand()) / double(RAND_MAX);

    return m * (-log(unif));
    }

 private:
  double x, m;
};

#endif
